unit lcars; {Library Control Access & Retrieval System}

INTERFACE
function lcars_compare(gamemode:byte;cscore:word):boolean;
{knihovne se preda jen skore, ktere je porovnano s existujicimi hiscores.
programu se vraci true, pokud se ma zeptat hrace na zadani jmena.}
procedure lcars_retrieve(gamemode:byte);
{precte hiscores pro zvoleny herni mod}
procedure lcars_store(gamemode:byte;nscore:word;nship:byte);
{ulozi novy vysledek do souboru, nejhorsi zapsany v souboru je tim smazan}

IMPLEMENTATION
uses vesa,klavesy,crt;
type hiscore=record
  player:string[15];
  score:word;
  ship:byte;
  end;
var soubor:file of hiscore;

procedure fileselect(gm:byte);
{vyber a otevreni souboru, se kterym se bude pracovat,
dostupne pouze uvnitr knihovny}
  begin
    case gm of
    1: assign(soubor,'timeatt.xhf');
    2: assign(soubor,'longrun.xhf');
    end;
    reset(soubor);
  end;{fileselect}

function lcars_compare(gamemode:byte;cscore:word):boolean;
  var jedenzaznam:hiscore;
  begin
    fileselect(gamemode);
    seek(soubor,19);
    read(soubor,jedenzaznam);
    if cscore>jedenzaznam.score
     then lcars_compare:=true
      else lcars_compare:=false;
    close(soubor);
  end;{compare}

procedure lcars_store(gamemode:byte;nscore:word;nship:byte);
  var i:byte;
      hsdata:array [1..20] of hiscore;
      key:char;
      jzaznam:hiscore;
  begin
    fileselect(gamemode);
    _setmode(0);
    for i:=1 to 20 do read(soubor,hsdata[i]);
    close(soubor);
    with hsdata[20] do begin
      ship:=nship;
      score:=nscore;
      textcolor(9);
      write('INPUT YOUR NAME: ');
      textcolor(2);
      readln(player);
      for i:=1 to length(player) do player[i]:=upcase(player[i]);
    end;
(*      player:='';
      i:=0;
      repeat
        key:=readkey;
        key:=upcase(key);
        if key<>'+' then begin
          player:=player+key;
          _print((16*i)+10,104,2,key);
        end;
        inc(i);
      until key='+';
    end;{with} *)
    i:=19;
    while (hsdata[i+1].score>hsdata[i].score) and (i>0) do begin
      jzaznam:=hsdata[i];
      hsdata[i]:=hsdata[i+1];
      hsdata[i+1]:=jzaznam;
      dec(i);
    end;
    rewrite(soubor);
    for i:=1 to 20 do write(soubor,hsdata[i]);
    close(soubor);
  end;{store}

(* procedure lcars_store(gamemode:byte;nname:string;nscore:word;nship:byte);
  var i:byte;
      hsdata:array [1..20] of hiscore;
      jzaznam:hiscore;
  begin
    fileselect(gamemode);
    for i:=1 to 20 do read(soubor,hsdata[i]);
    with hsdata[20] do begin
      player:=nname;
      score:=nscore;
      ship:=nship;
    end;
    i:=19;
    while hsdata[i+1].score>hsdata[i].score do begin
      jzaznam:=hsdata[i];
      hsdata[i]:=hsdata[i+1];
      hsdata[i+1]:=jzaznam;
      dec(i);
    end;
    seek(soubor,0);
    for i:=1 to 20 do write(soubor,hsdata[i]);
    close(soubor);
  end;{store} *)

procedure lcars_retrieve(gamemode:byte);
  var zaznam:hiscore;
      i:byte;
      pomocny:string[15];
  begin
    fileselect(gamemode);
    for i:=1 to 20 do begin
       read(soubor,zaznam);
       str(i,pomocny);
       if i<10 then pomocny:=(' ')+pomocny;
       pomocny:=pomocny+('.');
       _print(50,142+(24*i),2,pomocny);
       pomocny:=zaznam.player;
       _print(110,142+(24*i),54,pomocny);
       str(zaznam.score,pomocny);
       if zaznam.score<10000 then pomocny:=(' ')+pomocny;
       if zaznam.score<1000 then pomocny:=(' ')+pomocny;
       _print(470,142+(24*i),2,pomocny);
       case zaznam.ship of
       1: pomocny:='EXCELSIOR';
       2: pomocny:='AKIRA';
       3: pomocny:='DEFIANT';
       end;{case}
       _print(750,142+(24*i),54,pomocny);
     end;{for}
     close(soubor);
  end;{retrieve}

END.