unit fleet;

interface
procedure powerup_cross(puhx,puhy:integer;color:byte);
procedure excelsior(excelsior_x,excelsior_y:word);
procedure akira(akira_x,akira_y:integer);
procedure defiant(defiant_x,defiant_y:integer);
procedure astbig(abx,aby:integer);
procedure astsml(asx,asy:integer);
procedure mine(mnx,mny:integer);
procedure galor(glx,gly:integer);
procedure keldon(klx,kly:integer);
procedure hideki(hdx,hdy:integer);
procedure zamerovac(trgx,trgy:integer;barva:byte);
procedure poskozeni(x,y:integer);

implementation
uses vesa,oblouky;

procedure powerup_cross(puhx,puhy:integer;color:byte);
  begin
    _ellipse(puhx,puhy,25,25,color);
    _hline(puhx-20,puhx-7,puhy+7,color);
    _hline(puhx-20,puhx-7,puhy-7,color);
    _hline(puhx+7,puhx+20,puhy+7,color);
    _hline(puhx+7,puhx+20,puhy-7,color);
    _vline(puhx+7,puhy+7,puhy+20,color);
    _vline(puhx-7,puhy+7,puhy+20,color);
    _vline(puhx-20,puhy-7,puhy+7,color);
    _vline(puhx+20,puhy-7,puhy+7,color);
    _vline(puhx-7,puhy-20,puhy-7,color);
    _vline(puhx+7,puhy-20,puhy-7,color);
    _hline(puhx-7,puhx+7,puhy-20,color);
    _hline(puhx-7,puhx+7,puhy+20,color);
  end;{pwu_health}

procedure excelsior(excelsior_x,excelsior_y:word);
  begin
    {saucer, bridge and the blue painting}
    _ellipse(excelsior_x,excelsior_y,28,28,7);
    _ellipse(excelsior_x,excelsior_y,10,10,1);
    _ellipse(excelsior_x,excelsior_y,5,5,22);
    _vline(excelsior_x-10,excelsior_y,excelsior_y+26,1);
    _vline(excelsior_x+10,excelsior_y,excelsior_y+26,1);
    {impulse engines}
    _vline(excelsior_x+11,excelsior_y+27,excelsior_y+36,7);
    _vline(excelsior_x-11,excelsior_y+27,excelsior_y+36,7);
    _hline(excelsior_x-11,excelsior_x+11,excelsior_y+36,7);
    _hline(excelsior_x-11,excelsior_x-1,excelsior_y+37,39);
    _hline(excelsior_x+1,excelsior_x+11,excelsior_y+37,39);
    _vline(excelsior_x,excelsior_y+29,excelsior_y+36,26);
    {secondary hull}
    _vline(excelsior_x-12,excelsior_y+27,excelsior_y+55,25);
    _vline(excelsior_x+12,excelsior_y+27,excelsior_y+55,25);
    _ellipse(excelsior_x,excelsior_y+59,4,8,27);
    _hline(excelsior_x+4,excelsior_x+19,excelsior_y+56,26);
    _hline(excelsior_x-19,excelsior_x-4,excelsior_y+56,26);
    _hline(excelsior_x+4,excelsior_x+19,excelsior_y+62,26);
    _hline(excelsior_x-19,excelsior_x-4,excelsior_y+62,26);
    _line(excelsior_x-10,excelsior_y+63,excelsior_x,excelsior_y+85,25);
    _line(excelsior_x+10,excelsior_y+63,excelsior_x,excelsior_y+85,25);
    {port nacelle}
    _vline(excelsior_x-20,excelsior_y+43,excelsior_y+100,7);
    _vline(excelsior_x-24,excelsior_y+43,excelsior_y+100,7);
    _hline(excelsior_x-24,excelsior_x-20,excelsior_y+42,26);
    _bar(excelsior_x-23,excelsior_y+48,excelsior_x-21,excelsior_y+85,1);
    _hline(excelsior_x-24,excelsior_x-20,excelsior_y+100,26);
    {starboard nacelle}
    _vline(excelsior_x+20,excelsior_y+43,excelsior_y+100,7);
    _vline(excelsior_x+24,excelsior_y+43,excelsior_y+100,7);
    _hline(excelsior_x+20,excelsior_x+24,excelsior_y+42,26);
    _bar(excelsior_x+21,excelsior_y+48,excelsior_x+23,excelsior_y+85,1);
    _hline(excelsior_x+20,excelsior_x+24,excelsior_y+100,26);
  end;{excelsior}

procedure akira(akira_x,akira_y:integer);
  begin
    _oblouk(akira_x,akira_y,301,239,7,38,32,26);
    _oblouk(akira_x,akira_y,345,195,6,30,24,21);
    _ellipse(akira_x,akira_y+5,2,4,25);
    {pylons}
    _vline(akira_x-13,akira_y-10,akira_y+63,7);
    _vline(akira_x+13,akira_y-10,akira_y+63,7);
    _vline(akira_x+19,akira_y,akira_y+37,25);
    _vline(akira_x-19,akira_y,akira_y+37,25);
    _line(akira_x-13,akira_y-10,akira_x-19,akira_y,25);
    _line(akira_x+13,akira_y-10,akira_x+19,akira_y,25);
    _hline(akira_x-6,akira_x+6,akira_y+27,25);
    _line(akira_x+6,akira_y+27,akira_x+12,akira_y+45,25);
    _line(akira_x-6,akira_y+27,akira_x-12,akira_y+45,25);
    _line(akira_x+19,akira_y+37,akira_x+23,akira_y+53,26);
    _line(akira_x-19,akira_y+37,akira_x-23,akira_y+53,26);
    _line(akira_x+23,akira_y+53,akira_x+38,akira_y+60,25);
    _line(akira_x-23,akira_y+53,akira_x-38,akira_y+60,25);
    {launcher pod}
    _hline(akira_x-6,akira_x+6,akira_y+48,28);
    _vline(akira_x-6,akira_y+48,akira_y+61,28);
    _vline(akira_x+6,akira_y+48,akira_y+61,28);
    _line(akira_x+6,akira_y+61,akira_x,akira_y+66,28);
    _line(akira_x-6,akira_y+61,akira_x,akira_y+66,28);
    _line(akira_x-7,akira_y+51,akira_x-13,akira_y+54,26);
    _line(akira_x+7,akira_y+51,akira_x+13,akira_y+54,26);
    _line(akira_x+7,akira_y+58,akira_x+13,akira_y+62,26);
    _line(akira_x-7,akira_y+58,akira_x-13,akira_y+62,26);
    {nacelles}
    _vline(akira_x+40,akira_y+40,akira_y+75,54);
    _vline(akira_x+39,akira_y+30,akira_y+80,24);
    _vline(akira_x-40,akira_y+40,akira_y+75,54);
    _vline(akira_x-39,akira_y+30,akira_y+80,24);
    _vline(akira_x-40,akira_y+76,akira_y+80,24);
    _vline(akira_x-40,akira_y+31,akira_y+39,24);
    _vline(akira_x+40,akira_y+76,akira_y+80,24);
    _vline(akira_x+40,akira_y+31,akira_y+39,24);
    _line(akira_x-40,akira_y+31,akira_x-39,akira_y+30,40);
    _line(akira_x+40,akira_y+31,akira_x+39,akira_y+30,40);
    _line(akira_x+39,akira_y+72,akira_x+13,akira_y+63,24);
    _vline(akira_x+23,akira_y+53,akira_y+65,23);
    _vline(akira_x-23,akira_y+53,akira_y+65,23);
    _line(akira_x-39,akira_y+72,akira_x-13,akira_y+63,24);
  end;{akira}

procedure defiant(defiant_x,defiant_y:integer);
  begin
    _ellipse(defiant_x,defiant_y,7,7,26);
    _line(defiant_x-21,defiant_y-3,defiant_x-17,defiant_y+13,7);
    _line(defiant_x+21,defiant_y-3,defiant_x+17,defiant_y+13,7);
    _line(defiant_x-21,defiant_y-3,defiant_x-14,defiant_y-5,7);
    _line(defiant_x+21,defiant_y-3,defiant_x+14,defiant_y-5,7);
    _line(defiant_x+17,defiant_y+13,defiant_x+10,defiant_y+11,7);
    _line(defiant_x-17,defiant_y+13,defiant_x-10,defiant_y+11,7);
    _line(defiant_x-16,defiant_y+14,defiant_x-12,defiant_y+12,54);
    _line(defiant_x+16,defiant_y+14,defiant_x+12,defiant_y+12,54);
    _line(defiant_x-14,defiant_y-5,defiant_x-10,defiant_y+11,7);
    _line(defiant_x+14,defiant_y-5,defiant_x+10,defiant_y+11,7);
    _oblouk(defiant_x,defiant_y,15,70,5,15,20,26);
    _oblouk(defiant_x,defiant_y,110,165,5,15,20,26);
    _line(defiant_x-11,defiant_y+13,defiant_x-6,defiant_y+24,26);
    _line(defiant_x+11,defiant_y+13,defiant_x+6,defiant_y+24,26);
    _hline(defiant_x-6,defiant_x+6,defiant_y+24,26);
    _line(defiant_x-7,defiant_y+2,defiant_x-3,defiant_y+17,110);
    _line(defiant_x+7,defiant_y+2,defiant_x+3,defiant_y+17,110);
    _hline(defiant_x-5,defiant_x+5,defiant_y-14,7);
    _hline(defiant_x-3,defiant_x+3,defiant_y-26,7);
    _line(defiant_x-3,defiant_y-26,defiant_x-5,defiant_y-14,7);
    _line(defiant_x+3,defiant_y-26,defiant_x+5,defiant_y-14,7);
  end;{defiant}

procedure astbig(abx,aby:integer); {Big Mean Asteroid}
  begin
   if (aby<61) or (aby>_maxy-61) then begin
    __hline(abx-30,abx+30,aby-52,6);
    __hline(abx-30,abx+30,aby+52,6);
    __line(abx+30,aby-52,abx+60,aby,6);
    __line(abx-30,aby-52,abx-60,aby,6);
    __line(abx-60,aby,abx-30,aby+52,6);
    __line(abx+60,aby,abx+30,aby+52,6);
   end else begin
    _hline(abx-30,abx+30,aby-52,6);
    _hline(abx-30,abx+30,aby+52,6);
    _line(abx+30,aby-52,abx+60,aby,6);
    _line(abx-30,aby-52,abx-60,aby,6);
    _line(abx-60,aby,abx-30,aby+52,6);
    _line(abx+60,aby,abx+30,aby+52,6);
   end;
  end;{astbig}

procedure astsml(asx,asy:integer); {Small Mean Asteroid}
  begin
   if (asy<32) or (asy>_maxy-32) then begin
    __hline(asx-15,asx+15,asy-25,6);
    __hline(asx-15,asx+15,asy+25,6);
    __line(asx+15,asy-25,asx+30,asy,6);
    __line(asx-15,asy-25,asx-30,asy,6);
    __line(asx-30,asy,asx-15,asy+25,6);
    __line(asx+30,asy,asx+15,asy+25,6);
   end else begin
    _hline(asx-15,asx+15,asy-25,6);
    _hline(asx-15,asx+15,asy+25,6);
    _line(asx+15,asy-25,asx+30,asy,6);
    _line(asx-15,asy-25,asx-30,asy,6);
    _line(asx-30,asy,asx-15,asy+25,6);
    _line(asx+30,asy,asx+15,asy+25,6);
   end;
  end;{astsml}

procedure mine(mnx,mny:integer);
  begin
    _ellipse(mnx,mny,5,5,2);
    _putpixel(mnx-7,mny,2);
    _putpixel(mnx,mny-7,2);
    _putpixel(mnx+7,mny,2);
    _putpixel(mnx,mny+7,2);
    _putpixel(mnx,mny,2);
  end;{mine}

procedure gkcommon(gkx,gky:integer);{spolecne pro galor a keldon class}
  begin
    _hline(gkx-10,gkx+10,gky+15,66);
    _line(gkx+10,gky+15,gkx+25,gky+3,66);
    _line(gkx-10,gky+15,gkx-25,gky+3,66);
    _line(gkx-25,gky+3,gkx-32,gky-12,66);
    _line(gkx+25,gky+3,gkx+32,gky-12,66);
    _line(gkx+32,gky-12,gkx+8,gky-16,66);
    _line(gkx-32,gky-12,gkx-8,gky-16,66);
    _oblouk(gkx,gky+15,180,360,6,10,12,66);
    _oblouk(gkx,gky-5,190,350,6,6,10,67);
    _hline(gkx-5,gkx+5,gky-5,67);
    _line(gkx+8,gky-16,gkx+11,gky-8,66);
    _line(gkx-8,gky-16,gkx-11,gky-8,66);
    _vline(gkx-11,gky-8,gky-2,66);
    _vline(gkx+11,gky-8,gky-2,66);
  end;{gkcommon}

procedure gkcommon_k(gkkx,gkky:integer);{gkcommon s kontrolou}
  begin
    __hline(gkkx-10,gkkx+10,gkky+15,66);
    __line(gkkx+10,gkky+15,gkkx+25,gkky+3,66);
    __line(gkkx-10,gkky+15,gkkx-25,gkky+3,66);
    __line(gkkx-25,gkky+3,gkkx-32,gkky-12,66);
    __line(gkkx+25,gkky+3,gkkx+32,gkky-12,66);
    __line(gkkx+32,gkky-12,gkkx+8,gkky-16,66);
    __line(gkkx-32,gkky-12,gkkx-8,gkky-16,66);
    __oblouk(gkkx,gkky+15,180,360,6,10,12,66);
    __oblouk(gkkx,gkky-5,190,350,6,6,10,67);
    __hline(gkkx-5,gkkx+5,gkky-5,67);
    __line(gkkx+8,gkky-16,gkkx+11,gkky-8,66);
    __line(gkkx-8,gkky-16,gkkx-11,gkky-8,66);
    __vline(gkkx-11,gkky-8,gkky-2,66);
    __vline(gkkx+11,gkky-8,gkky-2,66);
  end;{gkcommon_K}

procedure galor(glx,gly:integer);
  begin
    if (gly<72) or (gly>_maxy-25) then begin
      gkcommon_k(glx,gly);
      __line(glx+8,gly-16,glx+2,gly-60,66);
      __line(glx-8,gly-16,glx-2,gly-60,66);
      __line(glx-1,gly-60,glx-4,gly-70,67);
      __line(glx+1,gly-60,glx+4,gly-70,67);
    end else begin
      gkcommon(glx,gly);
      _line(glx+8,gly-16,glx+2,gly-60,66);
      _line(glx-8,gly-16,glx-2,gly-60,66);
      _line(glx-1,gly-60,glx-4,gly-70,67);
      _line(glx+1,gly-60,glx+4,gly-70,67);
    end;
  end;{galor}

procedure keldon(klx,kly:integer);
  begin
    if (kly<72) or (kly>_maxy-25) then begin
      gkcommon_k(klx,kly);
      __line(klx-1,kly-60,klx-4,kly-70,67);
      __line(klx+1,kly-60,klx+4,kly-70,67);
      __line(klx+7,kly-13,klx+11,kly-26,67);
      __line(klx-7,kly-13,klx-11,kly-26,67);
      __hline(klx-7,klx+7,kly-13,67);
      __line(klx-11,kly-26,klx-5,kly-52,67);
      __line(klx+11,kly-26,klx+5,kly-52,67);
      __hline(klx-5,klx+5,kly-52,67);
      __line(klx-2,kly-60,klx-15,kly-66,66);
      __line(klx+2,kly-60,klx+15,kly-66,66);
      __vline(klx+15,kly-66,kly-57,66);
      __line(klx+15,kly-57,klx+6,kly-47,66);
      __line(klx-15,kly-57,klx-6,kly-47,66);
      __vline(klx-15,kly-66,kly-57,66);
    end else begin
      gkcommon(klx,kly);
      _line(klx-1,kly-60,klx-4,kly-70,67);
      _line(klx+1,kly-60,klx+4,kly-70,67);
      _line(klx+7,kly-13,klx+11,kly-26,67);
      _line(klx-7,kly-13,klx-11,kly-26,67);
      _hline(klx-7,klx+7,kly-13,67);
      _line(klx-11,kly-26,klx-5,kly-52,67);
      _line(klx+11,kly-26,klx+5,kly-52,67);
      _hline(klx-5,klx+5,kly-52,67);
      _line(klx-2,kly-60,klx-15,kly-66,66);
      _line(klx+2,kly-60,klx+15,kly-66,66);
      _vline(klx+15,kly-66,kly-57,66);
      _line(klx+15,kly-57,klx+6,kly-47,66);
      _line(klx-15,kly-57,klx-6,kly-47,66);
      _vline(klx-15,kly-66,kly-57,66);
    end;
  end;{keldon}

procedure hideki(hdx,hdy:integer);
  begin
   if (hdy<30) xor (hdy>746) then begin
    __ellipse(hdx,hdy,3,3,66);
    __oblouk(hdx,hdy-5,190,350,5,12,15,67);
    __line(hdx-3,hdy-1,hdx-5,hdy+2,67);
    __line(hdx-5,hdy+2,hdx-11,hdy-3,67);
    __line(hdx+3,hdy-1,hdx+5,hdy+2,67);
    __line(hdx+5,hdy+2,hdx+11,hdy-3,67);
    __line(hdx+3,hdy-2,hdx+2,hdy-13,2);
    __line(hdx-3,hdy-2,hdx-2,hdy-13,2);
    __line(hdx-1,hdy-13,hdx-3,hdy-16,66);
    __line(hdx+1,hdy-13,hdx+3,hdy-16,66);
    __vline(hdx,hdy+3,hdy+9,66);
   end else begin
    _ellipse(hdx,hdy,3,3,66);
    _oblouk(hdx,hdy-5,190,350,5,12,15,67);
    _line(hdx-3,hdy-1,hdx-5,hdy+2,67);
    _line(hdx-5,hdy+2,hdx-11,hdy-3,67);
    _line(hdx+3,hdy-1,hdx+5,hdy+2,67);
    _line(hdx+5,hdy+2,hdx+11,hdy-3,67);
    _line(hdx+3,hdy-2,hdx+2,hdy-13,2);
    _line(hdx-3,hdy-2,hdx-2,hdy-13,2);
    _line(hdx-1,hdy-13,hdx-3,hdy-16,66);
    _line(hdx+1,hdy-13,hdx+3,hdy-16,66);
    _vline(hdx,hdy+3,hdy+9,66);
   end;
  end;{hideki}

procedure zamerovac(trgx,trgy:integer;barva:byte);
  begin
    if (trgy>738) or (trgy<30) then begin
      __oblouk(trgx,trgy,25,65,8,43,43,barva);
      __oblouk(trgx,trgy,115,155,8,43,43,barva);
      __oblouk(trgx,trgy,205,245,8,43,43,barva);
      __oblouk(trgx,trgy,295,335,8,43,43,barva);
      __hline(trgx-7,trgx+7,trgy,barva);
      __vline(trgx,trgy-7,trgy+7,barva);
    end else begin
      _oblouk(trgx,trgy,25,65,8,43,43,barva);
      _oblouk(trgx,trgy,115,155,8,43,43,barva);
      _oblouk(trgx,trgy,205,245,8,43,43,barva);
      _oblouk(trgx,trgy,295,335,8,43,43,barva);
      _hline(trgx-7,trgx+7,trgy,barva);
      _vline(trgx,trgy-7,trgy+7,barva);
    end;
  end;{zamerovac}

procedure poskozeni(x,y:integer);
  begin
    _putpixel(x,y,22+random(8));
    _putpixel(x-1+random(3),y+1,22+random(8));
    _putpixel(x-2+random(6),y+2,22+random(8));
    _putpixel(x-2+random(6),y+3,22+random(8));
    _putpixel(x-3+random(8),y+4,22+random(8));
  end;{poskozeni}

end.